using System;
using System.Collections;
using System.Xml;
using System.Xml.XPath;
using NEOCOREXMSLib;

namespace NeoCoreFAQ001
{
	/// <summary>
	/// \IuWFNg
	/// </summary>
	public class XmlQuestions : System.Xml.XmlDocument
	{
		private string id;

		/// <summary>
		/// \IuWFNg𐶐܂
		/// </summary>
		public XmlQuestions()
		{
		}

		/// <summary>
		/// id^Ď\IuWFNg𐶐܂
		/// </summary>
		/// <param name="id">id</param>
		public XmlQuestions(string id) 
		{
			this.id = id;
		}

		/// <summary>
		/// id^Ď\IuWFNg𐶐ANoeCoreXmlf[^ǂݍ݂܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="id">id</param>
		/// <param name="status">Xe[^X "open"/"close"</param>
		public XmlQuestions(NeoCoreAPI neo, string id, string status) 
		{
			this.id = id;
			getXmlFromNeoCore(neo, id, status);
		}

		/// <summary>
		/// 񓚑҂P܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public void updateWaiting(NeoCoreAPI neo) 
		{
			headerUpdate(neo);
		}

		/// <summary>
		/// fromurl^Ot܂
		/// </summary>
		/// <param name="from">URL</param>
		public void addFrom(string from) 
		{
			XmlNode q = this.DocumentElement.SelectSingleNode("Questions");
			XmlElement new_elem = this.CreateElement("fromurl");
			new_elem.InnerText = from;
			if ( new_elem.InnerText.Length <= 0 ) 
			{
				new_elem.InnerText = "JavaScript:history.back()";
			}
			q.AppendChild(new_elem);
		}

		/// <summary>
		/// Xe[^XXVAXṼXe[^XԂ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public string statusUpdate(NeoCoreAPI neo) 
		{
			string cur = this.DocumentElement.SelectSingleNode("Questions/header[id='" + this.id + "']/status").InnerText;
			string chgStr = "open";
			if ( cur == "open" ) 
			{
				chgStr = "close";
			}
			neo.modifyXML("/ND/Questions/header[id='" + this.id + "']/status", "<status>" + chgStr + "</status>");
			return chgStr;
		}

		/// <summary>
		/// JJXVAXṼXe[^XԂ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public string secretUpdate(NeoCoreAPI neo) 
		{
			XmlNode cur = this.DocumentElement.SelectSingleNode("Questions/header[id='" + this.id + "']/secret");
			string chgStr = null;
			if ( cur == null ) 
			{
				neo.insertXML("/ND/Questions/header[id='" + this.id + "']/status", "<secret />");
				chgStr = "secret";
			}
			else 
			{
				neo.deleteXML("/ND/Questions/header[id='" + this.id + "']/secret");
			}
			return chgStr;
		}

		/// <summary>
		/// ݂̉񓚑҂Ԃ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public int getWaiting() 
		{
			return int.Parse(this.DocumentElement.SelectSingleNode("Questions/header/waiting").InnerText);
		}

		/// <summary>
		/// ݂̏ԂԂ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public string getStatus() 
		{
			return this.DocumentElement.SelectSingleNode("Questions/header/status").InnerText;
		}

		/// <summary>
		/// ݂̏ԂԂ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public string getSecret() 
		{
			string ret = null;
			if ( this.DocumentElement.SelectSingleNode("Questions/header/secret") != null ) 
			{
				ret = "secret";
			}
			return ret;
		}

		/// <summary>
		/// ݂XMLhLgNeoCoreɃXgA܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="i">񓚑҂</param>
		public void storeXml(NeoCoreAPI neo) 
		{
			neo.storeXML(this.OuterXMLforStore(neo), "", "");
		}
		
		/// <summary>
		/// XgAXMLԂ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public string OuterXMLforStore(NeoCoreAPI neo) 
		{
			this.addHeaderInfo(neo);
			this.addQuestionInfo(1);
			return this.OuterXml; 
		}

		/// <summary>
		/// NoeCoreXmlf[^ǂݍ݂܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="id">id</param>
		/// <param name="status">Xe[^X "open"/"close"</param>
		public void getXmlFromNeoCore(NeoCoreAPI neo, string id, string status)
		{
			if ( status.Length > 0 ) 
			{
				this.LoadXml(neo.queryXML("/ND/Questions[header/status='" + status + "' and header/id='" + id + "']"));
			}
			else 
			{
				this.LoadXml(neo.queryXML("/ND/Questions[header/id='" + id + "']"));
			}
		}


		/// <summary>
		/// Ƃ̊Kw\tbgAŃ\[g܂
		/// </summary>
		public void ToFlat() 
		{
			// Ƃ̊Kw\tbg
			XmlNode detail = this.DocumentElement.SelectSingleNode("Questions/detail");
			ToFlatNode(detail, "question/answer");
			XPathNavigator nav = this.CreateNavigator();
			// Ń\[g
			XPathExpression expr;
			expr = nav.Compile("/Query-Results/Questions/detail/child::node()");
			expr.AddSort("date", XmlSortOrder.Descending, XmlCaseOrder.None, "", XmlDataType.Text);
			XPathNodeIterator iterator = nav.Select(expr);
			while (iterator.MoveNext())
			{
				detail.AppendChild(((IHasXmlNode)iterator.Current).GetNode());
			}
		}

		/// <summary>
		/// Ƃ̊Kw\tbg܂
		/// </summary>
		/// <param name="tgtnode">detailm[h</param>
		/// <param name="flattgt">tbgΏۃm[h</param>
		private void ToFlatNode(XmlNode tgtnode, string flattgt) 
		{
			XmlNodeList tgtList = tgtnode.SelectNodes(flattgt);
			for ( int i=0; i<tgtList.Count; i++ ) 
			{
				XmlNode newnode = tgtnode.AppendChild(tgtList[i]);
				string new_flattgt = "question/answer";
				if ( flattgt == "question/answer" ) 
				{
					new_flattgt = "answer/question";
				}
				ToFlatNode(tgtnode, new_flattgt);
			}
		}

		/// <summary>
		/// 񓚑҂AŏIXVtXV܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="i">񓚑҂</param>
		private void headerUpdate(NeoCoreAPI neo) 
		{
			int w = this.countWaiting();
			neo.modifyXML("/ND/Questions/header[id='" + id + "']/waiting", "<waiting>" + w.ToString() + "</waiting>");
			neo.modifyXML("/ND/Questions/header[id='" + id + "']/last-updated", "<last-updated>" + System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "</last-updated>");
		}

		/// <summary>
		/// 񓚑҂JEg܂
		/// </summary>
		private int countWaiting() 
		{
			XmlNode detail = this.DocumentElement.SelectSingleNode("Questions/detail");
			return this.countWaitingNode(detail.SelectSingleNode("question"));
		}

		/// <summary>
		/// m[hPʂ̉񓚑҂JEg܂
		/// </summary>
		private int countWaitingNode(XmlNode node) 
		{
			XmlNodeList answers = node.SelectNodes("answer");
			int cnt = 0;
			if ( answers.Count == 0 ) 
			{
				cnt = 1;
			}
			else 
			{
				for ( int i=0; i<answers.Count; i++ ) 
				{
					XmlNodeList child_questions = answers[i].SelectNodes("question");
					for ( int j=0; j<child_questions.Count; j++ ) 
					{
						cnt += this.countWaitingNode(child_questions[j]);
					}
				}
			}
			return cnt;
		}

		/// <summary>
		/// wb_t܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		private void addHeaderInfo(NeoCoreAPI neo) 
		{
			string xml_id = this.getNextID(neo);

			XmlNode header = this.DocumentElement.SelectSingleNode("header");

			XmlElement new_elem1 = this.CreateElement("register-date");
			XmlElement new_elem2 = this.CreateElement("last-updated");
			XmlElement new_elem3 = this.CreateElement("id");
			XmlElement new_elem4 = this.CreateElement("status");
			XmlElement new_elem5 = this.CreateElement("waiting");
			
			new_elem1.InnerText = System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
			new_elem2.InnerText = System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
			new_elem3.InnerText = xml_id;
			new_elem4.InnerText = "open";
			new_elem5.InnerText = "1";
			
			header.AppendChild(new_elem1);
			header.AppendChild(new_elem2);
			header.AppendChild(new_elem3);
			header.AppendChild(new_elem4);
			header.AppendChild(new_elem5);
		}
		
		/// <summary>
		/// qidAtt܂
		/// </summary>
		/// <param name="qid">qid</param>
		private void addQuestionInfo(int qid) 
		{
			XmlNode q = this.DocumentElement.SelectSingleNode("detail/question");

			XmlElement new_elem1 = this.CreateElement("qid");
			XmlElement new_elem2 = this.CreateElement("date");
			
			new_elem1.InnerText = qid.ToString();
			new_elem2.InnerText = System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
			
			q.AppendChild(new_elem1);
			q.AppendChild(new_elem2);
		}

		/// <summary>
		/// id̔Ԃ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		private string getNextID(NeoCoreAPI neo) 
		{
			XmlDocument doc = new XmlDocument();
			doc.LoadXml(neo.queryXML("/ND/Questions/header/id"));
			XmlNodeList qList = doc.SelectNodes("/Query-Results/id");			

			if ( qList.Count == 0 ) 
			{
				return "1";
			}
			else 
			{
				int max_id = 0;
				for(int i=0; i<qList.Count; i++) 
				{
					int cur_id = int.Parse(qList[i].InnerText);
					if ( cur_id > max_id ) max_id = cur_id;
				}
				int next_id = max_id + 1;
				return next_id.ToString();
			}
		}
		
	}
}
